
#ifdef CLUSTER_LAM_MPI
#include "MpiFunctions.h"
#include <mpi.h>


int MPI_Comm_size_our()
{
	int nSize;
	MPI_Comm_size(MPI_COMM_WORLD, &nSize);
	return nSize;
}

int MPI_Comm_rank_our()
{
	int nNode;
	MPI_Comm_rank(MPI_COMM_WORLD, &nNode);
	return nNode;
}

void MPI_Finalize_our()
{
	MPI_Finalize();
}

void MPI_Barrier_our()
{
	MPI_Barrier(MPI_COMM_WORLD);
}

void MPI_Send_char(char* str, int len, int nNode, int nType)
{
	if(nNode==MPI_ANY_SOURCE_OUR)
		nNode = MPI_ANY_SOURCE;
	MPI_Send (str,len,MPI_CHAR,nNode,nType,MPI_COMM_WORLD);
}

void MPI_Send_int(int* n, int cnt, int nNode, int nType)
{
	if(nNode==MPI_ANY_SOURCE_OUR)
		nNode = MPI_ANY_SOURCE;
	MPI_Send (n,cnt,MPI_INT,nNode,nType,MPI_COMM_WORLD);
}


void MPI_Send_float(float* f, int cnt, int nNode, int nType)
{
	if(nNode==MPI_ANY_SOURCE_OUR)
		nNode = MPI_ANY_SOURCE;
	MPI_Send (f,cnt,MPI_FLOAT,nNode,nType,MPI_COMM_WORLD);
}

void MPI_Send_long(long* l, int cnt, int nNode, int nType)
{
	if(nNode==MPI_ANY_SOURCE_OUR)
		nNode = MPI_ANY_SOURCE;
	MPI_Send (l,cnt,MPI_LONG,nNode,nType,MPI_COMM_WORLD);
}

int MPI_Recv_char(char* str, int len, int nNode, int nType)
{
	if(nNode==MPI_ANY_SOURCE_OUR)
		nNode = MPI_ANY_SOURCE;
	MPI_Status status;
	MPI_Recv (str,len,MPI_CHAR,nNode,nType,MPI_COMM_WORLD,&status);
	return status.MPI_SOURCE;
}

int MPI_Recv_int(int* n, int cnt, int nNode, int nType)
{
	if(nNode==MPI_ANY_SOURCE_OUR)
		nNode = MPI_ANY_SOURCE;
	MPI_Status status;
	MPI_Recv (n,cnt,MPI_INT,nNode,nType,MPI_COMM_WORLD,&status);
	return status.MPI_SOURCE;
}

int MPI_Recv_float(float* f, int cnt, int nNode, int nType)
{
	if(nNode==MPI_ANY_SOURCE_OUR)
		nNode = MPI_ANY_SOURCE;
	MPI_Status status;
	MPI_Recv (f,cnt,MPI_FLOAT,nNode,nType,MPI_COMM_WORLD,&status);
	return status.MPI_SOURCE;
}

int MPI_Recv_long(long* l, int cnt, int nNode, int nType)
{
	if(nNode==MPI_ANY_SOURCE_OUR)
		nNode = MPI_ANY_SOURCE;
	MPI_Status status;
	MPI_Recv (l,cnt,MPI_LONG,nNode,nType,MPI_COMM_WORLD,&status);
	return status.MPI_SOURCE;
}

void MPI_Bcast_int(int* n, int cnt, int nNode)
{
	MPI_Bcast(n,cnt,MPI_INT,nNode,MPI_COMM_WORLD);
}


#endif //CLUSTER_LAM_MPI
